from vcCommand import *

app = getApplication()
teach = getApplication().TeachContext

def SelectMode(args):
  if mode.Value == "Component":
    component.IsVisible = True
    componentNode.IsVisible = False
  if mode.Value == "Component.Node":
    componentNode.IsVisible = True
    component.IsVisible = False

def OnStart():
  routine = teach.ActiveScope
  
  processStatement = routine.addStatement(VC_STATEMENT_PROCESS, teach.ActiveStatementIndex + 1, "rAttach")
  processStatement.Name = "Attach"+str(teach.ActiveStatementIndex + 1)
  
  name = processStatement.getProperty('Name')
  base = processStatement.getProperty('Base')
  tool = processStatement.getProperty('Tool')
  
  processStatement.createProperty(VC_STRING, 'Mode', VC_PROPERTY_STEP)
  processStatement.createProperty(VC_VECTOR, 'ParentVector')
  processStatement.createProperty(VC_STRING, 'Parent(Component)')
  processStatement.createProperty(VC_STRING, 'Parent(Component.Node)')
  processStatement.createProperty(VC_BUTTON, 'SetParentVector')
  
  processStatement.createProperty(VC_VECTOR, 'ChildVector')
  processStatement.createProperty(VC_STRING, 'Child')
  processStatement.createProperty(VC_BUTTON, 'SetChildVector')
  
  global mode, component, componentNode
  mode = processStatement.getProperty('Mode')
  component = processStatement.getProperty('Parent(Component)')
  componentNode = processStatement.getProperty('Parent(Component.Node)')
  
  component.IsVisible = False
  componentNode.IsVisible = False
  
  mode.StepValues = ["Component","Component.Node"]
  mode.OnChanged = SelectMode
  
  robot = teach.ActiveRobot 
  attachStatementScriptName = 'StatementScript_' + processStatement.Name
  attachStatementScript = robot.findBehaviour(attachStatementScriptName)
  if not attachStatementScript:
    attachStatementScript = robot.createBehaviour(VC_PYTHONPROCESSHANDLER, attachStatementScriptName)
  attachStatementScript.Script = '''
from vcPythonProcessHandler import *
import vcVector

app = getApplication()
snap = app.findCommand('interactiveSnap') 

def ParentPicked(arg):
  global mode, parentVector, parentName, parentNode, parentNodeComponent
  if mode.Value == "Component":
    target = snap.TargetNode.Component  
    parentVector.Value = target.WorldPositionMatrix.P
    parentName.Value = target.Name
  if mode.Value == "Component.Node":
    parentNodeComponent = snap.TargetNode.Component
    target = snap.TargetNode 
    parentVector.Value = target.WorldPositionMatrix.P
    parentNode.Value = target.Name

def ChildPicked(arg):
  global childVector, childName
  target = snap.TargetNode.Component  
  childVector.Value = target.WorldPositionMatrix.P
  childName.Value = target.Name
  
def OnPickComponent(arg):
  snap.clear() 
  if 'Parent' in arg.Name:
    snap.OnTargetSet = ParentPicked   
  elif 'Child' in arg.Name:
    snap.OnTargetSet = ChildPicked   
  snap.execute()

def hideOthers(statement):
  name = statement.getProperty('Name')
  name.IsVisible = False
  base = statement.getProperty('Base')
  base.IsVisible = False
  tool = statement.getProperty('Tool')
  tool.IsVisible = False

def setEvents(statement):
  global mode, parentVector, parentName, childVector, childName, parentNode
  
  mode = statement.getProperty('Mode')
  parentVector = statement.getProperty('ParentVector')
  parentName = statement.getProperty('Parent(Component)')
  childVector = statement.getProperty('ChildVector')
  childName = statement.getProperty('Child')
  parentNode = statement.getProperty('Parent(Component.Node)')
  
  global setParentVector, setChildVector
  setParentVector = statement.getProperty('SetParentVector')
  if setParentVector:
    if not setParentVector.OnChanged:
      setParentVector.OnChanged = OnPickComponent  
  setChildVector = statement.getProperty('SetChildVector')
  if setChildVector:
    if not setChildVector.OnChanged:
      setChildVector.OnChanged = OnPickComponent 

def OnStatementAdd(statement):
  # Hide others
  hideOthers(statement)
  
  # Set events
  setEvents(statement)

def OnStatementModified(statement):
  # Hide others
  hideOthers(statement)
  
  # Set events
  setEvents(statement)
  
def OnStatementExecute(executor, statement):  
  # Hide others
  hideOthers(statement)
  
  # Set events
  setEvents(statement)
  
  parent = None
  child = None
  
  if mode.Value == "Component":
    if parentName.Value != None and childName.Value != None:   
      parent = app.findComponent(parentName.Value)
      child = app.findComponent(childName.Value)          
      matrix = parent.InverseWorldPositionMatrix * child.WorldPositionMatrix
      parent.attach(child)
      child.PositionMatrix = matrix
  if mode.Value == "Component.Node":
    if parentNode.Value != None and childName.Value != None:
      parent = app.findComponent(parentNodeComponent.Name)
      child = app.findComponent(childName.Value) 
      node = parent.findNode(parentNode.Value)
      matrix = node.InverseWorldPositionMatrix * child.WorldPositionMatrix
      node.attach(child)
      child.PositionMatrix = matrix
    return



'''
  processStatement.Process = attachStatementScript
  app.SelectionManager.setSelection(processStatement)
